/*
 *  factor.c
 *  Joris van Rantwijk, Jan 2001
 */

#include <stdlib.h>
#include <stdio.h>

#define MAXN	1000
int prime[MAXN];

int main(void)
{
	int runs, n;
	int i, j, k, p, a;

	/* Sieve all primes <= MAXN */
	prime[0] = 0;
	for (i = 2; i <= MAXN; i++)
		prime[i-1] = 1;
	for (i = 2; i*i <= MAXN; i++)
		if (prime[i-1])
			for (j = i*i; j <= MAXN; j += i)
				prime[j-1] = 0;

	/* Convert to a list of primes */
	j = 0;
	for (i = 1; i <= MAXN; i++)
		if (prime[i-1])
			prime[j++] = i;
	prime[j] = MAXN + 1; /* sentinel value */

	scanf("%d", &runs);
	while ((runs--) > 0) {

		scanf("%d", &n);
		if (n < 2 || n > MAXN) {
			printf("Help! foute invoer : %d\n", n);
			exit(1);
		}

		/* Factor n! */
		printf("%d! = ", n);
		for (i = 0; (p = prime[i]) <= n; i++) {
			/* Compute exponent of p in n! */
			a = 0;
			k = p;
			while (k <= n) {
				a += n / k;
				k = k * p;
			}
			if (i > 0)
				printf(" * ");
			printf("%d", p);
			if (a > 1)
				printf("^%d", a);
		}
		printf("\n");
	}

	return 0;
}

/* end */
