/*
 *  factor.java
 *  Joris van Rantwijk, Jan 2001
 */

import java.io.StreamTokenizer;
import java.io.InputStreamReader;
import java.io.IOException;

class Factor {

	public static void main(String args[])
	{
		try {

			StreamTokenizer f = new StreamTokenizer(new InputStreamReader(System.in));
			f.resetSyntax();
			f.whitespaceChars(0, 32);
			f.wordChars(33, 127);

			f.nextToken();
			int runs = Integer.parseInt(f.sval);

			while ((runs--) > 0) {
				f.nextToken();
				int n = Integer.parseInt(f.sval);

				int p[] = new int[n+1];
				for (int i = 1; i <= n; i++)
					p[i] = 0;

				for (int k = 2; k <= n; k++) {
					int j = k;
					int i = 2;
					while (j != 1) {
						if (j % i == 0) {
							p[i]++;
							j = j / i;
						} else
							i++;
					}
				}

				System.out.print("" + n + "! = ");

				boolean first = true;
				for (int i = 1; i <= n; i++) {
					if (p[i] > 0) {
						if (!first)
							System.out.print(" * ");
						first = false;
						System.out.print(i);
						if (p[i] > 1)
							System.out.print("^" + p[i]);
					}
				}

				System.out.println();

			}

		} catch (IOException e) { System.err.println(e); }

	}

}

/* end */
