import java.io.*;

public class Harmonie
{
    

    public static void main(String [] args)
    {                  
        IntReader ir = new IntReader();                 
        for (int cases = ir.read(); cases > 0; cases--)
        {
            Problem problem = new Problem(ir);               
            problem.solve();
            System.out.println(problem.getSolution());               
        }                
    }
}

class Problem
{
    private static final int TWEE = 0, DRIE = 1, VIJF = 2;
    private static final int TERTS = 0, KWART = 1, KWINT = 2, OKTAAF = 3;
    private static final String [] naam = {" TERTS "," KWART ", " KWINT "," OKTAAF"};
    private static final String [] meervoud = {" TERTSEN "," KWARTEN ", " KWINTEN "," OKTAVEN" };

    int low, high;
    int [] interval = new int [4];
    boolean oplosbaar;

    public Problem(IntReader ir)
    {
        low  = ir.read();
        high = ir.read();
    }

    public void solve()
    {
        int [] exponent = new int [3];// 360 -> {3,2,1}
        int [] primes = {2,3,5};

        for (int k = 0 ; k < 3; k++)
        {
            while (high % primes[k] == 0)
            {
                high /= primes[k];
                exponent[k]++;
            }
            while (low % primes[k] == 0)
            {
                low /= primes[k];
                exponent[k]--;
            }
        }

        oplosbaar = high == low && exponent[VIJF] >= 0;
        if (oplosbaar)
        {
            interval[TERTS] = exponent[VIJF];
            exponent[VIJF]  = 0;
            exponent[TWEE] += 2 * interval[TERTS];            
            
            if (exponent[DRIE] > 0)
            {
                interval[KWINT] = exponent[DRIE];
                exponent[DRIE]  = 0;
                exponent[TWEE] += interval[KWINT];
            }
            else
            {
                interval[KWART] = - exponent[DRIE];
                exponent[DRIE]  = 0;
                exponent[TWEE] -= 2 * interval[KWART];
            }

            if (exponent[TWEE] >= 0)
            {
                interval[OKTAAF] = exponent[TWEE];
                exponent[TWEE]   = 0;
            }
            else
                oplosbaar = false;
        }
    }

    public String getSolution()
    {
        if (!oplosbaar)
            return "ONMOGELIJK";
        String antwoord = "";
        for (int k = 0; k < 4; k++)
            if (interval[k] > 0)
            {
                antwoord += interval[k];
                if (interval[k] == 1)
                    antwoord += naam[k];
                else
                    antwoord += meervoud[k];
            }
        return antwoord.trim();
    }

    public String toString()
    {
        return " " + low + " "  + high;
    }
}

class IntReader extends StreamTokenizer
{
    public IntReader(InputStream is)
    {
        super(is);
    }
    
    public IntReader()
    {
        this(System.in);
    }

    public int read()
    {
        try
        {
            int tokentype = nextToken();
        }
        catch(IOException iox){}
        return (int) nval;
    }
}