import java.io.*;
import java.util.*;

public class Quiz
{  
    public static void main(String [] args)
    {
        try
	    {              
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));                       
            String regel1     = br.readLine();            
            int aantal = Integer.parseInt(regel1);  
            for (int k = 0; k < aantal; k++)
	        {
	            QuizProblem problem  = new QuizProblem(br);	      
	            System.out.println(problem.getSolution() ? "JA" : "NEEN" );
	        }
	        br.close();		       	     
	    }
	    catch (IOException ioe)
	    {
	        System.out.println(ioe);
	    }
    }
}

class QuizProblem 
{
    boolean [] maakbaar = new boolean[1];
    int lengte = 1;
    int teMaken;

    public  QuizProblem (BufferedReader myReader) throws IOException
    {
        maakbaar[0] = true;
        String regel1 = myReader.readLine();
        IntScanner is = new IntScanner(regel1);        

        teMaken    = is.getInt();
        int aantal = is.getInt();       

        String regel2 = myReader.readLine();
        is = new IntScanner(regel2);

        for (int k = 0; k < aantal; k++)
        {
            int punten = is.getInt();
            addVraag(punten);
        }               
    }
    
    public void addVraag(int punten)
    {
        int lengteNieuw = lengte + punten;
        boolean [] maakbaarNieuw = new boolean[lengteNieuw];
        for (int p = 0; p < lengteNieuw; p++)
           maakbaarNieuw[p] = false;
        for (int p = 0; p < lengte; p++)
        if (maakbaar[p])
        {
            maakbaarNieuw[p] = true;
            maakbaarNieuw[p + punten] = true;
            maakbaarNieuw[Math.abs(p - punten)] = true;
        }
        maakbaar = maakbaarNieuw;
        lengte   = lengteNieuw;
    }

    public boolean getSolution()
    {
        if (teMaken >= lengte)
            return false;
        else    
            return maakbaar[teMaken];           
    }
}

class IntScanner extends StringTokenizer
{
    public IntScanner(String s)
    {
        super(s);
    }

    public int getInt()
    {
        String token = nextToken();
        return Integer.parseInt(token);
    }
}