import java.io.*;

public class ShannonMain
{
    public static void main(String [] args)
    {
        IntReader ir = new IntReader(System.in);
        for (int cases = ir.read(); cases > 0; cases--)
        {
            Shannon shannon = new Shannon(ir.read());
            System.out.println(shannon);
        }
    }

    private static void test (int m)
    {
        for(int k = -m; k <= m; k++)
        {
            Shannon shannon = new Shannon(k);
            if (!shannon.isOk())
                shannon.report();
        }
    }
}

class Shannon
{
    private static final int BASE    = 11;
    private static final int CIJFERS = 7 ;

    int getal;
    int[] shannon = new int[CIJFERS];

    public Shannon(int n)
    {
        getal = n;
        int k = 0;
        while (n !=0)
        {
            int ld = lastDigit(n);
            n = (n-ld) / BASE;
            shannon[k] = ld;
            k++;
        }
    }

    public boolean isOk()
    {
        int macht = 1;
        int n = 0;
        for (int k = 0; k < CIJFERS ; k++)
        {
            n += shannon[k] * macht;
            macht *= BASE;
        }
        return n == getal;
    }

    public String toString()
    {
        String antwoord = "";
        int k = CIJFERS - 1;
        while (k > 0 && shannon[k] == 0) k--; //skip leading zero's, but last
        while (k >= 0)
        {
            antwoord += toString(shannon[k]);
            k--;
        }
        return antwoord;
    }

    public void report()
    {
        System.out.println(getal + " " + toString());
    }

    private String toString(int n)
    {
        if (n < 0)
            return (-n) + "'";
        else
            return n + "";
    }

    private int lastDigit(int n)
    {
        int ld = n % BASE; // -BASE < ld < BASE
        if (2 * ld < -BASE)
            ld += BASE;
        if (2 * ld > BASE)
            ld -= BASE;
        return ld;
    }
}

class IntReader extends StreamTokenizer
{
    public IntReader(InputStream is)
    {
        super(is);
    }

    public int read()
    {
        try
        {
            int tokentype = nextToken();
        }
        catch(IOException iox){}
        return (int) nval;
    }
}
