/*
 *  Sleutels.java
 *  Lian Ien Oei
 */

import java.io.*;
class Sleutels
{
    public static void main(String[] args)
    {
        int aantalSets;

        try
        {
            StreamTokenizer f = new StreamTokenizer(new InputStreamReader(System.in));
            f.resetSyntax();
            f.whitespaceChars(0, 0x20);
            f.wordChars(0x21, 0xff);
            f.nextToken();
            aantalSets = Integer.parseInt(f.sval);
            
            for (int i = 0; i < aantalSets; i++)
            {
                // breedte van de sleutels
                f.nextToken();
                int b = Integer.parseInt(f.sval);

                // hoogte van de sleutels
                f.nextToken();
                int h = Integer.parseInt(f.sval);
                
                // aantal sleutels in de set
                f.nextToken();
                int n = Integer.parseInt(f.sval);
                
                String[] dezeSet = new String[n];
                
                for (int j = 0; j < n; j++)
                // voor iedere sleutel in deze set
                {
                    f.nextToken();
                    dezeSet[j] = f.sval;
                }
                
                // nu is de hele set ingelezen
                
                // de boolean goedeSet houdt bij of de gehele set goed is
                boolean goedeSet = true;
                
                // de array fouteSleutels houdt bij welke sleutels 'fout' zijn
                // (== deze sleutel zou door te vijlen omgezet kunnen worden 
                // in een (of meerdere) andere sleutel(s) uit dezelfde set)

                boolean[] fouteSleutels = new boolean[n];
                
                for (int j = 0; j < n; j++)
                {
                    fouteSleutels[j] = false;
                }
                
                // vergelijk alle sleutels in de set met elkaar
                for (int j = 0; j < n; j++)
                {
                    for (int k = j + 1; k < n; k++)
                    {
                        if (! (fouteSleutels[j] && fouteSleutels[k]))
                        // als beide sleutels als fout gemerkt staan, 
                        // hoef je natuurlijk niets te checken
                        {
                            int x = 0;
                            // x = 0 -> nog niets beslist
                            // x = 1 -> sleutel j < sleutel k
                            // x = 2 -> sleutel j > sleutel k
                            // x = 3 -> geen conflicten
                            
                            for (int l = 0; (l < b) && (x < 3); l++)
                            {
                                char charj = dezeSet[j].charAt(l);
                                char chark = dezeSet[k].charAt(l);
                                
                                if (! (charj == chark))
                                // de characters zijn verschillend
                                {
                                    if (charj < chark)
                                    {
                                        if (x == 0)
                                        {
                                            x = 1;
                                        }
                                        if (x == 2)
                                        {
                                            x = 3;
                                        }
                                    }
                                    else // charj > chark
                                    {
                                        if (x == 0)
                                        {
                                            x = 2;
                                        }
                                        if (x == 1)
                                        {
                                            x = 3;
                                        }
                                    }
                                }
                                
                                // als x = 3 (geen conflicten, dus er 
                                // is zowel een punt waar j<k, als een 
                                // punt waar j>k) wordt de loop verlaten
                            }
                            
                            // nu is bepaald of er een conflict is en zo ja 
                            // welk conflict
                            
                            if (x != 3) // als x = 3: geen conflicten 
                                        // -> niets doen
                            {
                                goedeSet = false;
                                
                                if (x == 1) // sleutel j < sleutel k
                                {
                                    fouteSleutels[k] = true;
                                }
                                else if (x == 2) // sleutel j > sleutel k
                                {
                                    fouteSleutels[j] = true;
                                }
                                else
                                {
                                    System.out.println("Error in Set " + 
                                    (i + 1) + " on keys " + (j + 1) + 
                                    "and " + (k + 1));
                                }
                            }
                        }
                    }
                }
                // nu is van iedere sleutel in de set bepaald of er een 
                // conflict is
                
                if (goedeSet)
                {
                    System.out.println("GOED");
                }
                else
                {
                    String s = "";
                    
                    for (int j = 0; j < n; j++)
                    {
                        if (fouteSleutels[j])
                        {
                            if (s.equals(""))
                            {
                                s = s + dezeSet[j];
                            }
                            else
                            {
                                s = s + " " + dezeSet[j];
                            }
                        }
                    }
                    System.out.println(s);
                }
            }
        } catch (IOException e) {System.err.println(e);}
    }
}
